include ../../components/editor
include ../../components/tcuploadmodal
include ../../meta/datatables

.container-fluid.p-0
    .row#cqHeader.col-grp-header
        .col
            h4.mt-2 Code Question Options
                span.float-right +
            hr.mt-0.mb-1
    .row.mt-2.collapse.col-grp-1.col-grp-4
        .col
            h5 Autocomplete Options
            .form-check
                if (codeqnOpts.autocomplete)
                    input.form-check-input#autoComp(type='checkbox', name='autoComp', checked=true)
                    label.form-check-label(for='autoComp') Enable Autocomplete
                else
                    input.form-check-input#autoComp(type='checkbox', name='autoComp')
                    label.form-check-label(for='autoComp') Enable Autocomplete
            .form-check
                if (codeqnOpts.manualcomplete)
                    input.form-check-input#manComp(type='checkbox', name='manComp', checked=true)
                    label.form-check-label(for='manComp') Requires manual invocation of autocomplete (Ctrl+Space)
                else
                    input.form-check-input#manComp(type='checkbox', name='manComp')
                    label.form-check-label(for='manComp') Requires manual invocation of autocomplete (Ctrl+Space)
        .col
            h5 Miscellaneous Options
            .form-check
                if (codeqnOpts.testfullsuite)
                    input.form-check-input#fullTestAllow(type='checkbox', name='fullTestAllow', checked=true)
                    label.form-check-label(for='fullTestAllow') Let quiz taker test against full test suite
                else
                    input.form-check-input#fullTestAllow(type='checkbox', name='fullTestAllow')
                    label.form-check-label(for='fullTestAllow') Let quiz taker test against full test suite
            .form-check
                if (codeqnOpts.genericerrors)
                    input.form-check-input#genericErr(type='checkbox', name='genericErr', checked=true)
                    label.form-check-label(for='genericErr') Show generic errors instead of full errors
                else
                    input.form-check-input#genericErr(type='checkbox', name='genericErr')
                    label.form-check-label(for='genericErr') Show generic errors instead of full errors
    .row#pclHeader.col-grp-header
        .col
            h4.mt-2 Primary Coding Language
                span.float-right +
            hr.mt-0.mb-1
    .row.collapse.col-grp-1.col-grp-2
        .col
            .form-group.required
                label(for='primaryLang') Primary Language
                select.form-control#primaryLang(required=true, name='primaryLang')
                    option(hidden=true, disabled=true, selected=true, value="") Select Primary Coding Language for this question

                    each lang in languages
                        if (lang.templatekey === codeTemplate.type)
                            option(value=lang.templatekey, selected=true)= lang.name
                        else
                            option(value=lang.templatekey)= lang.name
                div.invalid-feedback Please select a primary language for this question
        .col
            .form-group
                label.mr-2(for="name") Filename:
                input.form-control#name(type='text', placeholder='Filename', name='filename', value= codeTemplate.filename, pattern="^[a-zA-Z0-9.]+$")
                small#nameHelp.form-text.text-muted Leave empty to allow students to set their own filename if needed
                div.invalid-feedback Filename must not contain spaces
        .col
            .form-group.required
                label(for='codeDiff') Difficulty Level
                select.form-control#codeDiff(required=true, name='difficulty')
                    option(hidden=true, disabled=true, value="") Select Difficulty Level for Question
                    if codeqnOpts.difficulty === 0
                        option(value="0", selected=true) Easy
                    else
                        option(value="0") Easy
                    if codeqnOpts.difficulty === 1
                        option(value="1", selected=true) Medium
                    else
                        option(value="1") Medium
                    if codeqnOpts.difficulty === 2
                        option(value="2", selected=true) Hard
                    else
                        option(value="2") Hard
                div.invalid-feedback Please select a difficulty level for this question
    .row.collapse.col-grp-1.col-grp-2
        .col
            .form-group
                label Primary Langauge Code Template
                +codeEditor('', 1)
                small#codeEditHelp.form-text.text-muted Mark lines with %%* and *%% to denote read-only lines
                input.form-control#primaryCode(type='hidden', name='primaryCode')
                script $('#primaryLang').on('change', (e) => setlanguage($(e.target).val(), true, "#name"));
                script.
                    $(document).ready(() => {
                        let editor = ace.edit("codeEditor");
                        let tempKey = "#{codeTemplate.type}";
                        let lang = !{languagesStr};
                        for (let l of lang) {
                            if (l.templatekey === tempKey) {
                                if (l.alternatekey) tempKey = l.alternatekey;
                                break;
                            }
                        }
                        editor.getSession().setValue(`!{codeTemplate.template}`);
                        $('#primaryCode').val(editor.getSession().getValue());
                        editor.session.setMode(`ace/mode/${tempKey}`);
                        editor.getSession().on('change', () => {
                            $('#primaryCode').val(editor.getSession().getValue());
                        });
                    });
    .row#tcHeader.mt-2.col-grp-header
        .col
            h4 Test Cases
                span.float-right +
            hr.mt-0.mb-1
    .row.collapse.col-grp-1.col-grp-3
        .col
            h4 Sample Test Cases
            if clone==true 
                p(style="font-weight: bold;").bold NOTE: You can only add, update or delete the sample test cases after you have cloned the question.
            else
                span.text-muted These contains test cases that lets quiz takers test their code against before submission
                br
                span.text-muted Leave CPU or Memory Limit blank if there is no limits for that test case
            
    .row.collapse.col-grp-1.col-grp-3
        .col
            table#sampleTC.table.w-100
            script.
                $(document).ready(() => {
                    let sampurl;
                    var clone = #{clone};
                    if(clone==true)
                        sampurl = '/questions/info/#{bankid}/data/clonecode/stc/#{qnid}';
                    else 
                        sampurl = '/questions/info/#{bankid}/data/code/stc/#{qnid}';
                    let stcs = $('#sampleTC');
                    if(clone!=true){
                        stcs.DataTable({
                        ajax: sampurl,
                        dom: 'Brtilp',
                        responsive: true,
                        altEditor: true,
                        select: 'single',
                        deferRender: true,
                        pageLength: 2,
                        lengthMenu: [2, 5, 10, 20, 50, 100],
                        buttons: [
                            {text: 'Add', name: 'add'},
                            {extend: 'selected', text: 'Edit', name: 'edit'},
                            {extend: 'selected', text: 'Delete', name: 'delete'},
                            {text: 'Upload', action: () => $('#sampleUpload').modal()},
                            {
                                text: 'Clear All', className: 'btn-danger', action: () => {
                                    if (confirm("Are you sure you want to clear all test cases? THIS ACTION CANNOT BE REVERSED"))
                                        $.ajax({url: sampurl, type: 'DELETE', data: {type: "all"}, success: () => stcs.DataTable().ajax.reload()});
                                }
                            }
                        ],
                        columns: [
                            { title: 'ID', data: 'id', readonly: true, visible: false, type: 'hidden'},
                            { title: "Input", data: "inputCases", type: 'textarea', className: 'newlinesupport' },
                            { title: "Expected Output", data: "outputCases", type: 'textarea', className: 'newlinesupport' },
                            { title: "CPU Time Limit (s)", data: "cpulimit", type: 'number', min: '1' },
                            { title: "Memory Limit (MB)", data: "memlimit", type: 'number', min: '1' }
                        ],
                        onAddRow: function (datatable, rowdata, success, error) {$.ajax({url: sampurl, type: 'PUT', data: rowdata, success: success, error: error});},
                        onDeleteRow: function (datatable, rowdata, success, error) {$.ajax({url: sampurl, type: 'DELETE', data: rowdata, success: success, error: error});},
                        onEditRow: function (datatable, rowdata, success, error) {$.ajax({url: sampurl, type: 'POST', data: rowdata, success: success, error: error});}
                    });
                    }else{
                        stcs.DataTable({
                        ajax: sampurl,
                        dom: 'Brtilp',
                        responsive: true,
                        altEditor: true,
                        select: 'single',
                        deferRender: true,
                        pageLength: 2,
                        lengthMenu: [2, 5, 10, 20, 50, 100],
                        columns: [
                            { title: 'ID', data: 'id', readonly: true, visible: false, type: 'hidden'},
                            { title: "Input", data: "inputCases", type: 'textarea', className: 'newlinesupport' },
                            { title: "Expected Output", data: "outputCases", type: 'textarea', className: 'newlinesupport' },
                            { title: "CPU Time Limit (s)", data: "cpulimit", type: 'number', min: '1' },
                            { title: "Memory Limit (MB)", data: "memlimit", type: 'number', min: '1' }
                        ]
                    });
                    }
                });
    .row.collapse.col-grp-1.col-grp-3
        .col
            h4.required-nonfg#actualTCColor Actual Test Cases
            if clone==true 
                p(style="font-weight: bold;").bold NOTE: You can only add, update or delete the actual test cases after you have cloned the question.
            else
                span.text-muted These contains test cases that are hidden to quiz takers and are tested against when submitted (or when full test suite test option is checked).
                br
                span.text-muted If score is blank, the max score will be divided across number of test cases here. Scores will also be rounded off to 1 decimal place
    .row.collapse.col-grp-1.col-grp-3
        .col
            table#actualTC.table.w-100
            div#actualTCReq.invalid-feedback You need at least 1 test case in this section to update this question
            script.
                let actTable;
                $(document).ready(() => {
                    let acturl;
                    var clone = #{clone};
                    if(clone==true)
                        acturl = '/questions/info/#{bankid}/data/clonecode/atc/#{qnid}';
                    else 
                        acturl = '/questions/info/#{bankid}/data/code/atc/#{qnid}';
                    
                    let atcs = $('#actualTC');
                    if(clone!=true){
                        actTable = atcs.DataTable({
                        ajax: acturl,
                        dom: 'Brtilp',
                        responsive: true,
                        altEditor: true,
                        select: 'single',
                        deferRender: true,
                        pageLength: 2,
                        lengthMenu: [2, 5, 10, 20, 50, 100],
                        buttons: [
                            {text: 'Add', name: 'add'},
                            {extend: 'selected', text: 'Edit', name: 'edit'},
                            {extend: 'selected', text: 'Delete', name: 'delete'},
                            {text: 'Upload', action: () => $('#actualUpload').modal()},
                            {text: 'Clear All', className: 'btn-danger', action: () => {
                                    if (confirm("Are you sure you want to clear all test cases? THIS ACTION CANNOT BE REVERSED"))
                                        $.ajax({url: acturl, type: 'DELETE', data: {type: "all"}, success: () => atcs.DataTable().ajax.reload()});
                                }
                            }
                        ],
                        columns: [
                            {title: 'ID', data: 'id', readonly: true, visible: false, type: 'hidden'},
                            {title: "Input", data: "inputCases", type: 'textarea', className: 'newlinesupport'},
                            {title: "Expected Output", data: "outputCases", type: 'textarea', className: 'newlinesupport', required: true},
                            {title: "CPU Time Limit (s)", data: "cpulimit", type: 'number', min: '1'},
                            {title: "Memory Limit (MB)", data: "memlimit", type: 'number', min: '1'},
                            {title: "Score", data: "caseScore", type: 'number', step: 'any'}
                        ],
                        onAddRow: function (datatable, rowdata, success, error) {
                            $.ajax({url: acturl, type: 'PUT', data: rowdata, success: success, error: error});
                        },
                        onDeleteRow: function (datatable, rowdata, success, error) {
                            $.ajax({url: acturl, type: 'DELETE', data: rowdata, success: success, error: error});
                        },
                        onEditRow: function (datatable, rowdata, success, error) {
                            $.ajax({url: acturl, type: 'POST', data: rowdata, success: success, error: error});
                        }
                    });
                    }else{  // No Add, Edit, Remove buttons when cloning. 
                        actTable = atcs.DataTable({
                        ajax: acturl,
                        dom: 'Brtilp',
                        responsive: true,
                        altEditor: true,
                        select: 'single',
                        deferRender: true,
                        pageLength: 2,
                        lengthMenu: [2, 5, 10, 20, 50, 100],
                        columns: [
                            {title: 'ID', data: 'id', readonly: true, visible: false, type: 'hidden'},
                            {title: "Input", data: "inputCases", type: 'textarea', className: 'newlinesupport'},
                            {title: "Expected Output", data: "outputCases", type: 'textarea', className: 'newlinesupport', required: true},
                            {title: "CPU Time Limit (s)", data: "cpulimit", type: 'number', min: '1'},
                            {title: "Memory Limit (MB)", data: "memlimit", type: 'number', min: '1'},
                            {title: "Score", data: "caseScore", type: 'number', step: 'any'}
                        ]
                    });
                    }
                });

script.
    $(document).on("alteditor:delete_dialog_opened", () => {
        console.log("heyo");
        let modal_selector = $('#sampleTC')[0].altEditor.modal_selector;
        let ic = $(modal_selector).find("#Input").closest('div');
        ic.removeText();
        $("<span>Are you sure you wish to remove this test case? This cannot be reversed!</span>").insertAfter(ic);
        $(modal_selector).find("#Expected\\ Output").closest('div').removeText();
        $(modal_selector).find("label[for=inputCases]").remove();
        $(modal_selector).find("label[for=outputCases]").remove();
        $(modal_selector).find("#CPU\\ Time\\ Limit\\ \\(s\\)").closest('div').remove();
        $(modal_selector).find("#Memory\\ Limit\\ \\(MB\\)").closest('div').remove();

        modal_selector = $('#actualTC')[0].altEditor.modal_selector;
        ic = $(modal_selector).find("#Input").closest('div');
        ic.removeText();
        $("<span>Are you sure you wish to remove this test case? This cannot be reversed!</span>").insertAfter(ic);
        $(modal_selector).find("#Expected\\ Output").closest('div').removeText();
        $(modal_selector).find("label[for=inputCases]").remove();
        $(modal_selector).find("label[for=outputCases]").remove();
        $(modal_selector).find("label[for=caseScore]").remove();
        $(modal_selector).find("#CPU\\ Time\\ Limit\\ \\(s\\)").closest('div').remove();
        $(modal_selector).find("#Memory\\ Limit\\ \\(MB\\)").closest('div').remove();
        $(modal_selector).find("#Score").closest('div').removeText();
    });
script.
    $('#cqHeader').click(() => {$(".col-grp-1").collapse('hide'); $(".col-grp-4").collapse('show');$('.collapse-btn-adv').show();updateExp('#cqHeader',true);});
    $('#pclHeader').click(() => {$(".col-grp-1").collapse('hide'); $(".col-grp-2").collapse('show');$('.collapse-btn-adv').show();updateExp('#pclHeader',true);});
    $('#tcHeader').click(() => {$(".col-grp-1").collapse('hide');$(".col-grp-3").collapse('show');$('.collapse-btn-adv').show();updateExp('#tcHeader',true);});
script.
    function innerFormValidation(result) {
        let rowCnt = actTable.data().count();
        let tcNotFound = !rowCnt || rowCnt < 0;
        if (tcNotFound) {
            $("#actualTCReq").show();
            $("#actualTCColor").addClass("text-danger");
            return false;
        } else {
            $("#actualTCReq").hide();
            $("#actualTCColor").removeClass("text-danger");
        }
        return result;
    }

+testcaseupload(`/questions/info/${bankid}/data/code/stc/${qnid}/upload`, 'sampleUpload', 'sampleTC')
+testcaseupload(`/questions/info/${bankid}/data/code/atc/${qnid}/upload`, 'actualUpload', 'actualTC')